#ifndef IDFS_H
#define IDFS_H

#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include "QTMC_idfs_utils.h"
#include "idfs_retrieval.h"
#include "qdutil_copies.h"
#include "Qdos.h"
#include "Xrefs.h" //usual cocktail

//join a[i] to b[i] and put it in aj[i]
int join_components(QdObjectSeq_var a, QdObjectSeq_var b, QdObjectSeq_var aj);

//reads the calibration files and returns a scalar sequence of gain corrections
QdRScalarSeq_var read_n_rtn_cal_file(string calname);

//assign the FILLVAL val to the object obj
void assign_fillval(QdObject_var obj, double val);

//put the components x,y,z into a Dim(3) Matrix sequence (these are joined internally)
QdRMatrixSeq_var components_to_vector(QdRScalarSeq_var x, QdRScalarSeq_var y, QdRScalarSeq_var z);

//return a scalar sequence of data from sensor/mode from lineage lin between start and end.
//'clean' is true if you want to perform a cleaning operation and false if not
QdRScalarSeq_var ret_obj(IDFS_TIME start, IDFS_TIME end, IDFS_LINEAGE lin, SDDAS_SHORT sensor, SDDAS_CHAR type, bool clean);

//returns a conformal object ptr given an input (i.e. check for misplaced t-tags)
QdObject_var idfs_non_conformity(QdObject_var in);


#endif //IDFS_H
