#ifndef IDFS_RETRIEVAL_H
#define IDFS_RETRIEVAL_H

#ifdef __cplusplus
extern "C"{
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <math.h>
#include "ret_codes.h"
#include "user_defs.h"
#include "libVIDF.h"
#include "libbase_idfs.h"
#include "libdb.h"    
#include "libCfg.h" 
#include "libPromote.h"
#include "libserver.h"
#include "ant.h"
#include "QTMC_idfs_utils.h"   

//promotes if necessary the data from lineage in the range start->end described by data key
SDDAS_SHORT PROMOTE(IDFS_TIME start, IDFS_TIME end, IDFS_LINEAGE lineage, SDDAS_ULONG *data_key); 

//sets the IDFS_LINEAGE with pre-set array of const chars (see tmc_data.cpp)
void ASSIGN_LINEAGE(IDFS_LINEAGE *lin, const char * array[5]); 

//puts data in val for time ctime given data key, interval, idf_data stuct, etc.
//checks for fill vals and finds out what it is. returns -1 on error
int RETURN_DATA(double *val, SDDAS_ULONG *data_key, IDFS_TIME start, IDFS_TIME end,
                SDDAS_SHORT sensor, struct idf_data *exp_data, void * idfptr, 
        		    IDFS_LINEAGE *lin, char more_data, SDDAS_SHORT *ret_val, IDFS_TIME *ctime,
                SDDAS_CHAR type, SDDAS_CHAR chkfill, SDDAS_LONG lfill); 

//proceeds, if necessary, to the next file so data can be retrieved over many file changes		  
SDDAS_SHORT NEXT_FILE(SDDAS_SHORT ret_val, SDDAS_ULONG *data_key, IDFS_LINEAGE lin, void * idfptr, IDFS_TIME *etime, char more_data);

#ifdef __cplusplus
}
#endif

#endif    //IDFS_RETRIEVAL_H
