#ifndef QDUTIL_COPIES_H
#define QDUTIL_COPIES_H

#include <stdio.h>
#include <math.h>
#include "Qdos.h"
#include "Xrefs.h"

//cleans a matrix object
QdObject_var QuCleanObjectMatrix(QdObject_var dobj);

//sets the text attribute of obj attrName with the string value
void QuSetTxtAttr(char *attrName, char *value,  QdObject_var obj);

//tests if an object is a Dim(3) matrix
bool Qu_is3Vector(QdObject_var obj);

//tests if a time series has regular tags (can be used to determine tag spacing-->*spacing)
bool QuIsTSRegular(QdTimeSeq_var tt, double *spacing);

//returns a time sequence of the tags from obj
inline QdTimeSeq_var get_timetags(const QdObject_var& obj)
{
    QdTimeSeq_var nil_obj;
    if(obj.is_nil()) return  nil_obj;  // NULL var
    
    QdTimeSeq_var ts=QdTimeSeq_var::narrow(obj);
    if(ts.is_nil())
        if(obj->xref_exists(TIME_TAGS))
            ts=QdTimeSeq_var::narrow(obj->get_xref(TIME_TAGS));
    return ts;
}

//sets obj with the timetags ts
inline void set_timetags(QdObject_var obj, QdTimeSeq_var ts)
{
    if(obj->xref_exists(TIME_TAGS))
        obj->delete_xref(TIME_TAGS); 
    obj->set_xref(TIME_TAGS,ts);         
}


//checks for bad data and fills
bool QuIsBadData(double value, double fill);

//cleans a scalar sequence
QdRScalarSeq_var QuCleanObject(QdRScalarSeq_var dobj);


#endif //QDUTIL_COPIES_H
