#include "MatrixEig.h"
//#include <g2c.h>

namespace QDOS {

// --- Cover functions for CLAPACK routines
int eigcomp(char *jobz,char *uplo,long int *n,double *a, long int *lda,\
    double *w,long int *info)
{
// Cover function for doubles
    int res;
    long int lwork=(blcksize("DSYTRD",n)+2)**n;                   
    if (lwork<0)
    {
        throw MatrixValueError(ExceptionMsg()<<\
            "Internal error in CLAPACK: ILAENV()");
    }
    double *work=new double [lwork];
    res=dsyev_(jobz,uplo,n,a,lda,w,work,&lwork,info);
    if (0!=*info)
    {
        throw MatrixValueError(ExceptionMsg()<<\
            "Internal error in CLAPACK: DSYEV()");
    }
    delete work;
    return res;
}

long int blcksize(char *fname,long int *n)
{
    long int ispec=1;
    char *opts="L";
    long int junk=-1;         
    return ilaenv_(&ispec,fname,opts,n,n,&junk,&junk,strlen(fname),
    strlen(opts));
}                    

}  // end namespace QDOS        

