#include "write_data_files.h"
#include <ctime>


void write_cef_header(ofstream &out, const char * name, int records, int SC, bool B, bool L, bool H, bool T)
{

  const char * s;
  time_t now;
  struct tm *date;
  char time_str[50];
  time (&now);
  date = localtime(&now);
  strftime(time_str,50,"%Y-%m-%dT%H:%M:%SZ",date);

 if(T==1 && B==1 && L==1 && H==0)
 s = "BL1L2T";
 else if(T==1 && B==1 && H==1 && L==0)
 s = "BH1H2T";
 else if(T==0 && B==1 && H==1 && L==0)
 s="BH1H2";
 else if(T==0 && B==1 && L==1 && H==0)
 s="BL1L2";
 else if(T==1 && B==0 && H==1 && L==0)
 s="H1H2T";
 else if(T==1 && B==0 && L==1 && H==0)
 s="L1L2T";
 else if(T==0 && B==0 && H==1 && L==0)
 s="H1H2";
 else
 s="L1L2";

out << "!----- Cluster Exchange Version 2 ASCII File -----------|" << endl;
out << "! Free width data entries separated by delimiters       |" << endl;
out << "!                                                                                      |" << endl;
out << "! ASCII Format                                                              |" << endl;
out << "! Native C ordering, last index varies fastest          |" << endl;
out << "! Blank lines are ignored                                               |" << endl;
out << "! '!' escapes rest of line as comment                   |" << endl;
out << "!-------------------------------------------------------|" << endl;
out << "FILE_NAME =" <<  name << endl;
out << "FILE_FORMAT_VERSION = \"CEF-2.0\"" << endl;
out << "!" << endl;
out << "Attribute_delimiter = ," << endl;
out << "Data_delimiter = ," << endl;
out << "END_OF_RECORD_MARKER = \"\\n\"" << endl;
out << "RECORD_NUMBERING = \"OFF\"" << endl;
out << "!" << endl;
out << "START_META    = TITLE" << endl;
out << "  ENTRY       = \"Data created by Truncated Moments Corrector V1.2.0\"" << endl;
out << "END_META      = TITLE" << endl;
out << "!" << endl;
out << "START_META    = MODS" << endl;
out << "  ENTRY       = \"Data and/or timeline was processed by TMC\"" << endl;
out << "END_META      = MODS" << endl;
out << "!" << endl;
out << "START_META    = GENERATION_DATE" << endl;
out << "  VALUE_TYPE  = ISO_TIME" << endl;
out << "  ENTRY       = " << time_str << endl;
out << "END_META      = GENERATION_DATE" << endl;
out << "!" << endl;
out << "START_VARIABLE = time_tags" << endl;
out << "  ! scalar, no Size entry" << endl;
out << "  VALUE_TYPE   = ISO_TIME" << endl;
out << "  UNITS        = \"s\"" << endl;
out << "  LABLAXIS     = \"UT\"" << endl;
out << "  FIELDNAM     = \"Universal Time\"" << endl;
out << "  PARAMETER_TYPE     = Support_Data" << endl;
out << "END_VARIABLE   = time_tags" << endl;
out << "" << endl;
out << "START_VARIABLE     = V_e_xyz_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "  SIZES            =  3" << endl;
out << "  VALUE_TYPE       = FLOAT" << endl;
out << "  FIELDNAM         = \"Ve\"" << endl;
out << "  SI_CONVERSION    = \"1.e3>m s^-1\"" << endl;
out << "  UNITS            = \"km/s\"" << endl;
out << "  FILLVAL          = -3.4e+38" << endl;
out << "  FRAME            = \"vector>gse_xyz\"" << endl;
out << "  LABEL_1          = \"x\",\"y\",\"z\"" << endl;
out << "  LABLAXIS         = \"Ve\"" << endl;
out << "  REPRESENTATION_1 = \"x\",\"y\",\"z\"" << endl;
out << "  TENSOR_RANK      = 1" << endl;
out << "  TENSOR_FRAME     = \"gse\"" << endl;
out << "  SC_ID            = \"" << SC << "\"" << endl;
out << "  DEPEND_0         = time_tags" << endl;
out << "END_VARIABLE       = V_e_xyz_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "" << endl;

out << "START_VARIABLE    = v_T_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "! scalar, no Size entry" << endl;
out << "  VALUE_TYPE      = FLOAT" << endl;
out << "  FIELDNAM        = \"Thermal Speed\"" << endl;
out << "  FILLVAL         = -3.4e+38" << endl;
out << "  FRAME           = \"scalar>na\"" << endl;
out << "  LABLAXIS        = \"vT\"" << endl;
out << "  SC_ID           = \"" << SC << "\"" << endl;
out << "  DEPEND_0        = time_tags" << endl;
out << "  SI_CONVERSION   = \"1.e3>ms^-1\"" << endl;
out << "  UNITS           = \"km/s\"" << endl;
out << "END_VARIABLE      = v_T_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "" << endl;
out << "START_VARIABLE   = N_e_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "! scalar, no Size entry" << endl;
out << "  VALUE_TYPE     = FLOAT" << endl;
out << "  FIELDNAM       = \"Density\"" << endl;
out << "  LABLAXIS      = \"Ne\"" << endl;
out << "  FILLVAL        = -3.4e+38" << endl;
out << "  FRAME          = \"scalar>na\"" << endl;
out << "  SC_ID          = \" " << SC << "\"" << endl;
out << "  SI_CONVERSION  = \"1.e6>m^-3\"" << endl;
out << "  UNITS          = \"/cm**3\"" << endl;
out << "  DEPEND_0       = time_tags" << endl;
out << "END_VARIABLE     = N_e_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "" << endl;
out << "START_VARIABLE  = T_e_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "! scalar, no Size entry" << endl;
out << "  VALUE_TYPE    = FLOAT" << endl;
out << "  FIELDNAM      = \"Temperature\"" << endl;
out << "  FILLVAL       = -3.4e+38" << endl;
out << "  FRAME         = \"scalar>na\"" << endl;
out << "  LABLAXIS      = \"Te\"" << endl;
out << "  SC_ID         = \"" << SC << "\"" << endl;
out << "  SI_CONVERSION = \"1>K\"" << endl;
out << "  UNITS         = \"K\"" << endl;
out << "  DEPEND_0      = time_tags" << endl;
out << "END_VARIABLE    = T_e_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "" << endl;
out << "START_VARIABLE  = T_e_para_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "! scalar, no Size entry" << endl;
out << "  VALUE_TYPE    = FLOAT" << endl;
out << "  FIELDNAM      = \"Parallel Temperature\"" << endl;
out << "  FILLVAL       = -3.4e+38" << endl;
out << "  FRAME         = \"scalar>na\"" << endl;
out << "  LABLAXIS      = \"Te_para\"" << endl;
out << "  SC_ID         = \" " << SC << "\"" << endl;
out << "  SI_CONVERSION = \"1>K\"" << endl;
out << "  UNITS         = \"K\"" << endl;
out << "  DEPEND_0      = time_tags" << endl;
out << "END_VARIABLE    = T_e_para_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "" << endl;
out << "START_VARIABLE  = T_e_perp_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "! scalar, no Size entry" << endl;
out << "  VALUE_TYPE    = FLOAT" << endl;
out << "  FIELDNAM      =  \"Perpendicular Temperature\"" << endl;
out << "  FILLVAL       = -3.4e+38" << endl;
out << "  FRAME         = \"scalar>na\"" << endl;
out << "  LABLAXIS      = \"Te_perp\"" << endl;
out << "  SC_ID         = \"" << SC << "\"" << endl;
out << "  SI_CONVERSION = \"1>K\"" << endl;
out << "  UNITS         = \"K\"" << endl;
out << "  DEPEND_0      = time_tags" << endl;
out << "END_VARIABLE    = T_e_perp_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "" << endl;
out << "START_VARIABLE = r_T_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "! scalar, no Size entry" << endl;
out << "  VALUE_TYPE    = FLOAT" << endl;
out << "  FIELDNAM      = \"temperature estimation parameter\"" << endl;
out << "  FILLVAL       = -3.4e+38" << endl;
out << "  FRAME         = \"scalar>na\"" << endl;
out << "  SC_ID         = \"" << SC << "\"" << endl;
out << "  SI_CONVERSION = \"1>()\"" << endl;
out << "  UNITS         = \" \"" << endl;
out << "  LABLAXIS      = \"rT\"" << endl;
out << "  DEPEND_0      = time_tags" << endl;
out << "END_VARIABLE    = r_T_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "" << endl;
out << "START_VARIABLE  = r_N_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "! scalar, no Size entry" << endl;
out << "  FIELDNAM      = \"density estimation parameter\"" << endl;
out << "  VALUE_TYPE    = FLOAT" << endl;
out << "  FILLVAL       = -3.4e+38" << endl;
out << "  FRAME         = \"scalar>na\"" << endl;
out << "  SC_ID         = \"" << SC << "\"" << endl;
out << "  SI_CONVERSION = \"1>()\"" << endl;
out << "  UNITS         = \" \"" << endl;
out << "  LABLAXIS      = \"rN\"" << endl;
out << "  DEPEND_0      = time_tags" << endl;
out << "END_VARIABLE    = r_N_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "" << endl;
out << "START_VARIABLE  = r_V_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "! scalar, no Size entry" << endl;
out << "  FIELDNAM      = \"velocity estimation parameter\"" << endl;
out << "  VALUE_TYPE    = FLOAT" << endl;
out << "  FILLVAL       = -3.4e+38" << endl;
out << "  FRAME         = \"scalar>na\"" << endl;
out << "  SC_ID         = \"" << SC << "\"" << endl;
out << "  SI_CONVERSION = \"1>()\"" << endl;
out << "  UNITS         = \" \"" << endl;
out << "  LABLAXIS      = \"rV\"" << endl;
out << "  DEPEND_0      = time_tags" << endl;
out << "END_VARIABLE    = r_V_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "" << endl;
out << "START_VARIABLE  = I_est_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "! scalar, no Size entry" << endl;
out << "  FIELDNAM      = \"overall estimation parameter\"" << endl;
out << "  VALUE_TYPE    = FLOAT" << endl;
out << "  FILLVAL       = -3.4e+38" << endl;
out << "  FRAME         = \"scalar>na\"" << endl;
out << "  SC_ID         = \"" << SC << "\"" << endl;
out << "  SI_CONVERSION = \"1>()\"" << endl;
out << "  UNITS         = \" \"" << endl;
out << "  LABLAXIS      = \"Ie\"" << endl;
out << "  DEPEND_0      = time_tags" << endl;
out << "END_VARIABLE    = I_est_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "" << endl;
out << "START_VARIABLE  = err_code_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "! scalar, no Size entry" << endl;
out << "  VALUE_TYPE    = FLOAT" << endl;
out << "  FIELDNAM      = \"Solver Return Value\"" << endl;
out << "  FILLVAL       = -3.4e+38" << endl;
out << "  FRAME         = \"scalar>na\"" << endl;
out << "  LABLAXIS      = \"Res\"" << endl;
out << "  SC_ID         = \"" << SC << "\"" << endl;
out << "  SI_CONVERSION = \"1>()\"" << endl;
out << "  UNITS         = \"na\"" << endl;
out << "  DEPEND_0      = time_tags" << endl;
out << "END_VARIABLE    = err_code_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "" << endl;
out << "START_VARIABLE  = p_off_on_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "! scalar, no Size entry" << endl;
out << "  VALUE_TYPE    = FLOAT" << endl;
out << "  FIELDNAM      = \"ratio of off to on diagonal elements in p\"" << endl;
out << "  FILLVAL       = -3.4e+38" << endl;
out << "  FRAME         = \"scalar>na\"" << endl;
out << "  SC_ID         = \"" << SC << "\"" << endl;
out << "  SI_CONVERSION = \"1>()\"" << endl;
out << "  UNITS         = \"na\"" << endl;
out << "  LABLAXIS      = \"p_off_on\"" << endl;
out << "  DEPEND_0      = time_tags" << endl;
out << "END_VARIABLE    = p_off_on_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "" << endl;
out << "START_VARIABLE  = p_perp_ratio_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "! scalar, no Size entry" << endl;
out << "  FIELDNAM      = \"ratio of two perpendicular p components\"" << endl;
out << "  LABLAXIS      = \"p_perp_ratio\"" << endl;
out << "  VALUE_TYPE    = FLOAT" << endl;
out << "  FILLVAL       = -3.4e+38" << endl;
out << "  FRAME         = \"scalar>na\"" << endl;
out << "  SC_ID         = \"" << SC << "\"" << endl;
out << "  SI_CONVERSION = \"1>()\"" << endl;
out << "  UNITS         = \"na\"" << endl;
out << "  DEPEND_0      = time_tags" << endl;
out << "END_VARIABLE    = p_perp_ratio_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "  " << endl;
out << "START_VARIABLE  = phi_sc_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "! scalar, no Size entry" << endl;
out << "  FIELDNAM      = \"spacecraft potential\"" << endl;
out << "  UNITS         = \"V\"" << endl;
out << "  LABLAXIS      = \"phi_sc\"" << endl;
out << "  VALUE_TYPE    = FLOAT" << endl;
out << "  FILLVAL       = -3.4e+38" << endl;
out << "  FRAME         = \"scalar>na\"" << endl;
out << "  SC_ID         = \"" << SC << "\"" << endl;
out << "  SI_CONVERSION = \"1>V\"" << endl;
out << "  DEPEND_0      = time_tags" << endl;
out << "END_VARIABLE    = phi_sc_tmc_" << s << "__C" << SC << "_PL_PEA" << endl;
out << "! time_tags, Ve, vT, Ne, Te, Te_para, Te_perp, T_est, N_est, V_est, I_est, err_code, p_off_on, p_perp_ratio, phi_sc" << endl;
out << "" << endl;
out << "DATA_UNTIL = \"End_of_file\"" << endl;

}


void append_cef_record(ofstream &out, 
		       const char * time, 
		        double *vx, 
		        double *vy, 
		        double *vz, 
		        double *vT,
		        double *Density_n0, 
			double *T0, 
			double *T_para, 
			double *T_perp, 
			double *T_est, 
			double *N_est, 
			double *V_est, 
			double *Ie, 
			int *SolverRetValue, 
			double *p_off_on, 
			double *p_perp_ratio,
      double *phi_sc)
		       
{


out << time << ","
    << *vx << "," 
    << *vy << "," 
    << *vz << ","
    << *vT << ","
    << *Density_n0 << ","
    << *T0 << ","
    << *T_para << ","
    << *T_perp << ","
    << *T_est << ","
    << *N_est << ","
    << *V_est << ","
    << *Ie << ","
    << *SolverRetValue << ","
    << *p_off_on << ","
    << *p_perp_ratio << ","
    << *phi_sc <<  endl;

}

void append_qft_record(ofstream &out, 
		       const char * time, 
		        double *vx, 
		        double *vy, 
		        double *vz, 
		        double *vT,
		        double *Density_n0, 
			double *T0, 
			double *T_para, 
			double *T_perp, 
			double *T_est, 
			double *N_est, 
			double *V_est, 
			double *Ie, 
			int *SolverRetValue, 
			double *p_off_on, 
			double *p_perp_ratio,
      double *phi_sc)
		       
{


out << time << ","
    << *vx << "," 
    << *vy << "," 
    << *vz << ","
    << *vT << ","
    << *Density_n0 << ","
    << *T0 << ","
    << *T_para << ","
    << *T_perp << ","
    << *T_est << ","
    << *N_est << ","
    << *V_est << ","
    << *Ie << ","
    << *SolverRetValue << ","
    << *p_off_on << ","
    << *p_perp_ratio << ","
    << *phi_sc <<  endl;

}

const char * qftfilename(int spacecraft, int by, int bd, int bh, int bm, int ey, int ed, int eh, int em, bool B, bool L, bool H, bool T)
{
    
 int rcode = 0;
 
 char * buffer = new char[100];
// cout << "allocated buffer" << endl;
 const char * s = new char[100];
 //cout << "allocated s" << endl;
 
 if(T==1 && B==1 && L==1 && H==0)
 s = "BL1L2T";
 else if(T==1 && B==1 && H==1 && L==0)
 s = "BH1H2T";
 else if(T==0 && B==1 && H==1 && L==0)
 s="BH1H2";
 else if(T==0 && B==1 && L==1 && H==0)
 s="BL1L2";
 else if(T==1 && B==0 && H==1 && L==0)
 s="H1H2T";
 else if(T==1 && B==0 && L==1 && H==0)
 s="L1L2T";
 else if(T==0 && B==0 && H==1 && L==0)
 s="H1H2";
 else 
 s="L1L2";
 
// cout << "got through logic" << endl;
 
 rcode=sprintf (buffer, "TMC_SC%d_%d%03d%02d%02d_%d%03d%02d%02d_%s.qft", spacecraft, by, bd, bh, bm, ey, ed, eh, em, s);
 
// cout << "did sprintf" << endl;
 
 //cout << "buffer = " << buffer << endl;
 
 //delete s;
 
 //cout << "!deleted s" << endl;
	 
 return buffer;
    
}

const char * filename(int spacecraft, int by, int bd, int bh, int bm, int ey, int ed, int eh, int em, bool B, bool L, bool H, bool T)
{
    
 int rcode = 0;
 
 char * buffer = new char[100];
// cout << "allocated buffer" << endl;
 const char * s = new char[100];
 //cout << "allocated s" << endl;
 
 if(T==1 && B==1 && L==1 && H==0)
 s = "BL1L2T";
 else if(T==1 && B==1 && H==1 && L==0)
 s = "BH1H2T";
 else if(T==0 && B==1 && H==1 && L==0)
 s="BH1H2";
 else if(T==0 && B==1 && L==1 && H==0)
 s="BL1L2";
 else if(T==1 && B==0 && H==1 && L==0)
 s="H1H2T";
 else if(T==1 && B==0 && L==1 && H==0)
 s="L1L2T";
 else if(T==0 && B==0 && H==1 && L==0)
 s="H1H2";
 else 
 s="L1L2";
 
// cout << "got through logic" << endl;
 
 
 rcode=sprintf (buffer, "TMC_SC%d_%d%03d%02d%02d_%d%03d%02d%02d_%s.cef", spacecraft, by, bd, bh, bm, ey, ed, eh, em, s);
 
// cout << "did sprintf" << endl;
 
 //cout << "buffer = " << buffer << endl;
 
 //delete s;
 
 //cout << "!deleted s" << endl;
	 
 return buffer;
    
}


const char * logfilename(int spacecraft, int by, int bd, int bh, int bm, int ey, int ed, int eh, int em, bool B, bool L, bool H, bool T)
{
    
 int rcode = 0;
 
 char * buffer = new char[100];
// cout << "allocated buffer" << endl;
 const char * s = new char[100];
 //cout << "allocated s" << endl;
 
 if(T==1 && B==1 && L==1 && H==0)
 s = "BL1L2T";
 else if(T==1 && B==1 && H==1 && L==0)
 s = "BH1H2T";
 else if(T==0 && B==1 && H==1 && L==0)
 s="BH1H2";
 else if(T==0 && B==1 && L==1 && H==0)
 s="BL1L2";
 else if(T==1 && B==0 && H==1 && L==0)
 s="H1H2T";
 else if(T==1 && B==0 && L==1 && H==0)
 s="L1L2T";
 else if(T==0 && B==0 && H==1 && L==0)
 s="H1H2";
 else 
 s="L1L2";
 
// cout << "got through logic" << endl;
 
 
 rcode=sprintf (buffer, "TMC_SC%d_%d%03d%02d%02d_%d%03d%02d%02d_%s.log", spacecraft, by, bd, bh, bm, ey, ed, eh, em, s);
 
// cout << "did sprintf" << endl;
 
 //cout << "buffer = " << buffer << endl;
 
 //delete s;
 
 //cout << "!deleted s" << endl;
	 
 return buffer;
    
}
